using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Methods
{

		/* 
		 * C# Sample Code provided by BITWISE MAGAZINE
		 * 
		 *      http://www.bitwisemag.com
		 *
		 * This code and information is provided "as is" without warranty of
		 * any kind, either expressed or implied, including but not limited
		 * to the implied warranties of merchantability and/or fitness for a
		 * particular purpose.
		 *
		 * You may use and modify this code for your personal use only.
		 * You may also redistribute this code providing that
		 * a) No fee is charged and b) This copyright notice
		 * is retained in the source code.
		 *
		 * You may not use this code for commercial purposes
		 * without the express permission of the copyright holder
		 *
		 * Copyright (c) 2005 Huw Collingbourne 
		 *
		 */

	class a
	{
		public String method1()
		{
			return "class a: method1\r\n";
		}
		public virtual String method2()
		{
			return "class a: (virtual) method2\r\n";
		}
	}

	class b : a // class a is the ancestor of class b 
	{
		public new String method1() // note 'new' keyword 
		{
			return "class b: method1\r\n";
		}
		public override String method2()
		{
			return "class b: (override) method2\r\n";
		}
	}


	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.RichTextBox richTextBox1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.richTextBox1 = new System.Windows.Forms.RichTextBox();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(216, 472);
			this.button1.Name = "button1";
			this.button1.TabIndex = 0;
			this.button1.Text = "button1";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// richTextBox1
			// 
			this.richTextBox1.Dock = System.Windows.Forms.DockStyle.Top;
			this.richTextBox1.Font = new System.Drawing.Font("Microsoft Sans Serif", 14F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.richTextBox1.Name = "richTextBox1";
			this.richTextBox1.Size = new System.Drawing.Size(536, 448);
			this.richTextBox1.TabIndex = 1;
			this.richTextBox1.Text = "";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(536, 533);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.richTextBox1,
																		  this.button1});
			this.Name = "Form1";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			a mya1 = new a();
			b myb1 = new b();
		
	
			ArrayList al = new ArrayList();
			al.Add(mya1);			
			al.Add(myb1);

			richTextBox1.AppendText("=== Calling each object specifically ===\r\n");
			richTextBox1.AppendText(mya1.method1());			
			richTextBox1.AppendText(mya1.method2());
			richTextBox1.AppendText(myb1.method1());
			richTextBox1.AppendText(myb1.method2());	
			richTextBox1.AppendText("=== Calling each object as an instance of 'a' ===\r\n");
			foreach(a aOb in al)
			{			
				richTextBox1.AppendText("This object's class type is: " + aOb.ToString()+"\r\n");
				richTextBox1.AppendText(aOb.method1());			
				richTextBox1.AppendText(aOb.method2());			
			}
			
		}
	}
}
